// Copyright (C) 2014 Ben Asselstine
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
//  02110-1301, USA.
#ifndef CURLHELPER_H
#define CURLHELPER_H

#include <cstdio>
#include <gtkmm.h>
#include <string>
#include <sigc++/signal.h>
#include <sigc++/slot.h>
#include <curlpp/Easy.hpp>
class CurlHelper
{
public:
    struct Msg 
      {
        curlpp::Easy *easy;
        int response_code;
        const char *data;
        size_t len;
      };
  CurlHelper(Glib::ustring url, Glib::ustring tmpfile = "");
  ~CurlHelper();
  
  sigc::signal<bool, Msg&> signal_received() {return signal_recv;}
  sigc::signal<void, int, Glib::ustring> signal_downloaded() {return signal_down;}

  bool get();
  void download();
private:
  curlpp::Easy *easy;
  FILE *fileptr;
  std::string tmpfile;
  sigc::signal<bool, Msg&> signal_recv;
  sigc::signal<void, int, Glib::ustring> signal_down;
  bool remove_temp;
};
#endif
