// Copyright (C) 2014 Ben Asselstine
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
//  02110-1301, USA.
#ifndef GUNZIPHELPER_H
#define GUNZIPHELPER_H

#include <cstdio>
#include <gtkmm.h>
#include <string>
#include <sigc++/signal.h>
class GunzipHelper
{
public:
  GunzipHelper(Glib::ustring filename);
  ~GunzipHelper();
  
  static unsigned int chunk_size;
  static sigc::signal<void, Glib::ustring> signal;
  sigc::signal<void, Glib::ustring>& signal_unzipped() {return signal;}

  void gunzip();
private:
  std::string outfile;
  Glib::ustring infile;

  void on_file_ready(Glib::RefPtr<Gio::AsyncResult>& result, Glib::RefPtr<Gio::File> &f, Glib::RefPtr<Gio::File> &out);

  void on_stream_ready(Glib::RefPtr<Gio::AsyncResult>& result, Glib::RefPtr<Gio::FileInputStream> &s, Glib::RefPtr<Gio::ZlibDecompressor> gz, Glib::RefPtr<Gio::File> &out);
};
#endif
