//  Copyright (C) 2011, 2012, 2014 Ben Asselstine
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
//  02110-1301, USA.

#ifndef JAMENDO_TRACK_LIST_LOADER_H
#define JAMENDO_TRACK_LIST_LOADER_H
#include <gtkmm.h>
#include "curlhelper.h"
#include <map>
#include <libxml/tree.h>
class TrackList;
class Track;
class JamendoTrackListLoader
{
    public:

        //! Constructor.
        JamendoTrackListLoader();

	//! Destructor.
        ~JamendoTrackListLoader();

        void reset() {;};

        void get_license_image(Glib::ustring track_id, Glib::ustring license, sigc::slot<void, Glib::ustring, Glib::ustring> success_slot, sigc::slot<void,Glib::ustring> failure_slot);

        TrackList* parse(const char *filename);
    protected:
    private:
        TrackList *d_track_list;

        //callbacks

        bool on_license_image_downloaded(CurlHelper::Msg &msg, Glib::ustring track_id, Glib::ustring license, sigc::slot<void,Glib::ustring, Glib::ustring> success, sigc::slot<void,Glib::ustring> failure);

        //helpers
        void parse_tags(xmlNodePtr child, Glib::ustring &genre);
        void parse_tracks(xmlNodePtr child, TrackList *ts, Glib::ustring artist_name);
        void parse_albums(xmlNodePtr child, TrackList *tracklist, Glib::ustring artist_name);
        void parse(xmlNodePtr child, TrackList *tracklist);

        Glib::ustring get_license_name(const char *data);
        Glib::ustring lookup_genre(int genre_id);
};

#endif // JAMENDO_TRACK_LIST_LOADER_H
