//  Copyright (C) 2012, 2014 Ben Asselstine
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
//  02110-1301, USA.

#ifndef LICENSE_IMAGE_CACHE_H
#define LICENSE_IMAGE_CACHE_H
#include <gtkmm.h>
#include "curlhelper.h"
#include <map>
class LicenseImageCache
{
    public:

        //! Constructor.
        LicenseImageCache();

	//! Destructor.
        ~LicenseImageCache();

        void reset() {;}

        void get_image(Glib::ustring track_id, Glib::ustring license, sigc::slot<void, Glib::ustring, Glib::ustring, Glib::RefPtr<Gdk::Pixbuf> > success_slot, sigc::slot<void,Glib::ustring> failure_slot);

    protected:
    private:
        Glib::ustring dir;
        std::map<Glib::ustring, Glib::RefPtr<Gdk::Pixbuf> > license_images;

        //callbacks
        bool on_license_image_downloaded(CurlHelper::Msg &msg, Glib::ustring track_id, Glib::ustring license, sigc::slot<void,Glib::ustring, Glib::ustring, Glib::RefPtr<Gdk::Pixbuf> >, sigc::slot<void,Glib::ustring> );

        //helpers
        Glib::RefPtr<Gdk::Pixbuf> load_license_image_from_data(CurlHelper::Msg &msg);
        void add(Glib::ustring license, Glib::RefPtr<Gdk::Pixbuf> pixbuf);
        void load(Glib::ustring dir);
};

#endif // LICENSE_IMAGE_CACHE_H
